#include <sourcemod>
#include <sdktools>
#include <sdkhooks>
#include <multicolors>
#include <autoexecconfig>
#include <adminmenu>
#include <cstrike>

#pragma semicolon 1

#define DEBUG

#pragma newdecls required


char g_ChatPrefix[256];
ConVar gConVar_Chat_Prefix;

ConVar gConVar_RoundStart;
ConVar gConVar_RoundEnd;
ConVar gConVar_ForceStop;


#define m_flNextSecondaryAttack FindSendPropInfo("CBaseCombatWeapon", "m_flNextSecondaryAttack")


bool NoScopeRound = false;
bool NoScopeEnabled = false;
bool KnifeDamage = true;

//ADMIN MENU

Handle hAdminMenu;

public Plugin myinfo = 
{
	name = "NoScope Round", 
	author = "LanteJoula", 
	description = "NoScope Round !noscope", 
	version = "1.4", 
	url = "https://steamcommunity.com/id/lantejoula/"
};

public void OnPluginStart()
{
	LoadTranslations("noscoperound.phrases");
	
	//Menu
	RegAdminCmd("sm_nsr", Command_NoScope, ADMFLAG_GENERIC);
	RegAdminCmd("sm_noscoperound", Command_NoScope, ADMFLAG_GENERIC);
	RegAdminCmd("sm_noscope", Command_NoScope, ADMFLAG_GENERIC);
	
	//Events
	HookEvent("round_end", OnRoundEnd);
	
	AutoExecConfig_SetFile("plugin.noscoperound");
	
	gConVar_Chat_Prefix = AutoExecConfig_CreateConVar("sm_noscoperound_chat_prefix", "[{green}TAG{default}]", "Chat Prefix");
	
	gConVar_RoundStart = AutoExecConfig_CreateConVar("sm_noscoperound_round_start_message", "1", "Enable/Disable the Message when NoScope Round Start (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_RoundEnd = AutoExecConfig_CreateConVar("sm_noscoperound_round_end_message", "1", "Enable/Disable the Message when NoScope Round End (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_ForceStop = AutoExecConfig_CreateConVar("sm_noscoperound_round_forcestop_message", "1", "Enable/Disable the Message when Staff Force Stop the NoScope Round(1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	
	AutoExecConfig_ExecuteFile();
	AutoExecConfig_CleanFile();
	
	gConVar_Chat_Prefix.AddChangeHook(OnPrefixChange);
	
	//RegPluginLibrary
	RegPluginLibrary("noscoperound");
}

////////
//Prefix
////////

public void SavePrefix()
{
	GetConVarString(gConVar_Chat_Prefix, g_ChatPrefix, sizeof(g_ChatPrefix));
}

public void OnConfigsExecuted()
{
	SavePrefix();
}

public void OnPrefixChange(ConVar cvar, char[] oldvalue, char[] newvalue)
{
	SavePrefix();
}

////////
//PLUGIN
////////

//////
//MENU
//////

public Action Command_NoScope(int client, int args)
{
	ShowMenu(client);
}

void ShowMenu(int client)
{
	char StartVote1[128];
	char PreStartMenu1[128];
	char ForceStopMenu1[128];
	
	Menu menu = new Menu(Menu_Handler);
	menu.SetTitle("%t\n ", "NoScope Round Title");
	
	Format(StartVote1, sizeof(StartVote1), "%t", "StartVote");
	menu.AddItem("1", StartVote1);
	
	if (!NoScopeRound)
	{
		Format(PreStartMenu1, sizeof(PreStartMenu1), "%t", "PreStartMenu");
		menu.AddItem("2", PreStartMenu1);
	}
	else
	{
		Format(ForceStopMenu1, sizeof(ForceStopMenu1), "%t", "ForceStopMenu");
		menu.AddItem("3", ForceStopMenu1);
	}
	menu.ExitButton = true;
	menu.Display(client, MENU_TIME_FOREVER);
}

public int Menu_Handler(Menu menu, MenuAction action, int client, int args)
{
	if (action == MenuAction_Select)
	{
		char selectedItem[200];
		menu.GetItem(args, selectedItem, sizeof(selectedItem));
		if (StrEqual(selectedItem, "1"))
		{
			FakeClientCommand(client, "sm_vote \"%t\"", "NoScopeRoundVote");
		}
		if (StrEqual(selectedItem, "2"))
		{
			NoScopeRound = true;
			NoScopeEnabled = true;
			KnifeDamage = false;
			
			CreateTimer(0.1, RemovePistols, _, TIMER_FLAG_NO_MAPCHANGE);
			
			if (gConVar_RoundStart.BoolValue)
				CPrintToChatAll("%s %t", g_ChatPrefix, "Round Start");
		}
		if (StrEqual(selectedItem, "3"))
		{
			NoScopeRound = false;
			NoScopeEnabled = false;
			KnifeDamage = true;
			
			char name[128];
			GetClientName(client, name, sizeof(name));
			
			if (gConVar_ForceStop.BoolValue)
				CPrintToChatAll("%s %t", g_ChatPrefix, "Force Stop", name);
			
			CreateTimer(0.1, GivePistols, _, TIMER_FLAG_NO_MAPCHANGE);
			
			for (int i = 1; i <= MaxClients; i++)
			{
				if (IsValidClient(i) && IsPlayerAlive(i))
				{
					for (int j = 0; j < 5; j++)
					{
						int weapon = GetPlayerWeaponSlot(i, j);
						if (weapon == -1)
						{
							continue;
						}
						char item[128];
						GetEdictClassname(weapon, item, sizeof(item));
						if (isNoScopeWeapon(item))
						{
							SetEntDataFloat(weapon, m_flNextSecondaryAttack, 0.0);
						}
					}
				}
			}
		}
	}
	else if (action == MenuAction_End)
	{
		delete menu;
	}
}

public Action RemovePistols(Handle timer)
{
	for (int i = 1; i <= MaxClients; i++)
	{
		if (IsClientInGame(i))
		{
			int Secondary = GetPlayerWeaponSlot(i, CS_SLOT_SECONDARY);
			
			if (Secondary != -1)
			{
				RemovePlayerItem(i, Secondary);
			}
		}
	}
}

public Action GivePistols(Handle timer)
{
	for (int i = 1; i <= MaxClients; i++)
	{
		if (IsClientInGame(i))
		{
			int Secondary = GetPlayerWeaponSlot(i, CS_SLOT_SECONDARY);
			char name[32];
			
			if (Secondary != -1)
			{
				GetEdictClassname(Secondary, name, sizeof(name));
				if (!StrEqual(name, "weapon_deagle"))
				{
					RemovePlayerItem(i, Secondary);
					GivePlayerItem(i, "weapon_deagle");
				}
			}
			else
			{
				GivePlayerItem(i, "weapon_deagle");
			}
		}
	}
}

bool isNoScopeWeapon(char[] weapon)
{
	if (StrEqual(weapon, "weapon_scout")
		 || StrEqual(weapon, "weapon_g3sg1")
		 || StrEqual(weapon, "weapon_ssg08")
		 || StrEqual(weapon, "weapon_aug")
		 || StrEqual(weapon, "weapon_sg556")
		 || StrEqual(weapon, "weapon_awp")
		 || StrEqual(weapon, "weapon_scar20"))
	return true;
	return false;
}

public Action OnRoundEnd(Event event, const char[] name, bool dontBroadcast)
{
	if (NoScopeRound)
	{
		NoScopeRound = false;
		NoScopeEnabled = false;
		KnifeDamage = true;
		
		if (gConVar_RoundEnd.BoolValue)
			CPrintToChatAll("%s %t", g_ChatPrefix, "Round End");
	}
}

public void OnClientPutInServer(int client)
{
	//NOSCOPE
	SDKHook(client, SDKHook_PreThink, PreThink);
	
	//KNIFE DAMAGE
	SDKHook(client, SDKHook_OnTakeDamage, TakeDamageHook);
}

public Action PreThink(int client)
{
	if (IsPlayerAlive(client))
	{
		int weapon = GetEntPropEnt(client, Prop_Send, "m_hActiveWeapon");
		if (!IsValidEdict(weapon))
			return Plugin_Continue;
		
		char item[64];
		GetEdictClassname(weapon, item, sizeof(item));
		
		if (NoScopeEnabled && isNoScopeWeapon(item))
		{
			SetEntDataFloat(weapon, m_flNextSecondaryAttack, GetGameTime() + 9999.9); //Disable Scope
		}
	}
	return Plugin_Continue;
}

public Action Event_RoundEnd(Handle event, const char[] name, bool dontBroadcast)
{
	if (NoScopeEnabled)
	{
		CPrintToChatAll("[{green}NOSCOPE{default}] Parabéns aos Vencedores. Dano de faca será {green}ativado {default}na próxima ronda!");
		
		NoScopeRound = false;
		NoScopeEnabled = false;
		KnifeDamage = true;
	}
}

//////////////
//KNIFE DAMAGE
//////////////

public Action TakeDamageHook(int client, int &attacker, int &inflictor, float &damage, int &damagetype)
{
	if (!KnifeDamage)
	{
		if ((client >= 1) && (client <= MaxClients) && (attacker >= 1) && (attacker <= MaxClients) && (attacker == inflictor))
		{
			char WeaponName[64];
			GetClientWeapon(attacker, WeaponName, sizeof(WeaponName));
			if (StrContains(WeaponName, "knife", false) != -1)
			{
				damage = 0.0;
				return Plugin_Changed;
			}
		}
	}
	return Plugin_Continue;
}

///////////////
//ISVALIDCLIENT
///////////////

stock bool IsValidClient(int client)
{
	return (1 <= client <= MaxClients && IsClientInGame(client) && !IsClientSourceTV(client));
}


////////////
//ADMIN MENU
////////////

public void OnAllPluginsLoaded()
{
	if (!LibraryExists("especialrounds")) //WITH ESPECIALS ROUNDS
	{
		Handle topmenu;
		if (LibraryExists("adminmenu") && ((topmenu = GetAdminTopMenu()) != null))
			OnAdminMenuReady(topmenu);
	}
}

public void OnAdminMenuReady(Handle topmenu)
{
	if (topmenu == hAdminMenu)
		return;
	
	hAdminMenu = topmenu;
	CreateTimer(1.0, Timer_AttachAdminMenu);
}

public Action Timer_AttachAdminMenu(Handle timer)
{
	TopMenuObject menu_category = AddToTopMenu(hAdminMenu, "noscope", TopMenuObject_Category, Handle_Category, INVALID_TOPMENUOBJECT, "noscope", ADMFLAG_GENERIC);
	if (menu_category == INVALID_TOPMENUOBJECT)
		return;
	
	AddToTopMenu(hAdminMenu, "sm_noscope", TopMenuObject_Item, AdminMenu_NoScopeRound, menu_category, "sm_noscope", ADMFLAG_GENERIC);
}

public void Handle_Category(TopMenu topmenu, TopMenuAction action, TopMenuObject topobj_id, int param, char[] buffer, int maxlength)
{
	if (action == TopMenuAction_DisplayTitle)
		Format(buffer, maxlength, "%T", "NoScope Round Title in Admin", param);
	else if (action == TopMenuAction_DisplayOption)
		Format(buffer, maxlength, "%T", "NoScope Round Title in Admin", param);
}

public void AdminMenu_NoScopeRound(TopMenu topmenu, TopMenuAction action, TopMenuObject topobj_id, int param, char[] buffer, int maxlength)
{
	if (action == TopMenuAction_DisplayOption)
		Format(buffer, maxlength, "%T", "NoScope Round Buttom in Admin", param);
	else if (action == TopMenuAction_SelectOption)
		ShowMenu(param);
} 